/*
 *		+++ J A R D I N +++
 */

/*    ============================================================    */
/*
 *	new  Sat Dec 30 15:27:08 UTC 2023
 */

#declare Tete_Totem = object
{
#local RTT = 0.41;
merge	{
	difference {
		sphere { <0, 0>, RTT scale <2.50, 1, 1> }
		box { <-1, -1, -1>, <-0.0000001, 1, 1> }
		}
	sphere { <0, 0>, RTT  }
	}
scale <1, 0.75, 1>

texture {
	pigment {
		gradient y
#include "neonmap.incc"
		turbulence 0.16 scale 0.64
		}
	} // fin texture
rotate -z * (19 - (abs(sin(NormClock*51)) * 40))
}

#declare Corps_Totem = object
{
merge {
	cylinder { <0, 0, 0>, <0, 5, 0>, 0.19 }

	/* la base */
	cylinder { <0, 0, 0>, <0, 0.22, 0>, 0.96 }
	cone { <0, 0.22, 0>, 0.96, <0, 0.28, 0>, 0.21 }
	}
texture {
	pigment {
		gradient y
#include "neonmap.incc"
		turbulence 0.16	scale 0.56
		}
	} // fin texture
}

#declare Totem_Jardin = object
{
union	{
	object { Tete_Totem rotate -y*(1.8*clock) translate y*5 }
	object { Corps_Totem }
	}
}

/*    ============================================================    */
/*    new from the Mon 20 Mar 2023 01:05:27 AM CET */

#declare Barre_Clocheton = object
{
box { <-0.045, 0, -0.045>, <0.045, 8, 0.045> }
}

#declare Le_Clocheton = object
{
#local EB = 0.53;
union	{
	cylinder { <0, 0, 0>, <0, 0.08, 0>, EB*2.22	}
	object { Barre_Clocheton translate <-EB, 0, -EB> }
	object { Barre_Clocheton translate < EB, 0, -EB> }
	object { Barre_Clocheton translate <-EB, 0,  EB> }
	object { Barre_Clocheton translate < EB, 0,  EB> }
	#for (foo, 0.20, 7.90, 0.51)
	  cylinder { <-EB, foo, -EB>, < EB, foo, EB> 0.03 }
	  cylinder { < EB, foo, -EB>, <-EB, foo, EB> 0.03 }
	#end
	}
texture { MON_VERT_INDUS }
}

/*    ============================================================    */

#declare Forme_Pyramide_a = object
{
#local HP = 4.85;
 prism {
    conic_sweep
    linear_spline
    0,			// height 1
    1,			// height 2
    5,			// the number of points making up the shape...
    <4,4>,<-4,4>,<-4,-4>,<4,-4>,<4,4>

    rotate <180, 0, 0>
    scale <1, HP, 1>
    translate y*HP
  }
#undef HP
}

#declare Forme_Pyramide = object
{
difference {
	object { Forme_Pyramide_a }
	object { Forme_Pyramide_a translate -0.30*y }
	cylinder { <-6, 0,  0>, <6, 0, 0>, 1.45 scale <1, 1.30, 1> }
	cylinder { < 0, 0, -6>, <0, 0, 0>, 1.45 scale <1, 1.30, 1> }
	}
texture { TURQ_BOZO scale 2.80 }
}

#local Coin_Base_P = object
{
union	{
	cone { 0,      0.22, 1.33*y, 0.001 }
	cone { 0.80*y, 0.17, 1.46*y, 0.001 }
	}
}

#declare Base_Pyramide = object
{
#local B = 4.63;
#local C = B - 0.30;
union	{
	box { <-B, 0, -B>, <B, 0.80, B> }
	object { Coin_Base_P	translate <-C, 0.80, -C> }
	object { Coin_Base_P	translate < C, 0.80, -C> }
	object { Coin_Base_P	translate <-C, 0.80,  C> }
	object { Coin_Base_P	translate < C, 0.80,  C> }
	}
texture { TEINTE_BASIQUE }
}

#declare Pyramide = object
{ 
union	{
	object { Base_Pyramide }
	object { Forme_Pyramide translate <0, 0.85, 0> }
	light_source {
		<0, 2.30, 0> color <0.9, 0.2, 0.2>
		fade_distance   (FADE_D * 0.95)
		fade_power      (FADE_P * 1.30)
		}
	// object { Repere scale 5 translate <0, 2.10, 0> }
	}
scale 0.94
}

/*    ============================================================    */

#declare EX_pergola = 1.75;
#declare EZ_pergola = EX_pergola * 1.67;
#declare SZ_poutre  = 0.030;
#declare H1_pergola = 2.40;
#declare HK_pergola = 0.92;
#declare H2_pergola = H1_pergola + HK_pergola;

#declare Pergola_pied = object
{
#local E = SZ_poutre;
#local F = SZ_poutre * 1.28;
#local G = 0.14;
union	{
	box { <-F, -F, -F>, <F, F, F> translate y*H1_pergola }
	box { <-E, 0, -E>, <E, H1_pergola, E> }
	box { <-G, 0, -G>, <G, 0.03,       G> }
	/* XXX */
	}
pigment { color Gray80 }
}

#declare Pergola_les_pieds = object
{
union	{
	#local EX = EX_pergola;
	#local EZ = EZ_pergola;
	object { Pergola_pied		translate <-EX, 0, -EZ> }
	object { Pergola_pied		translate < EX, 0, -EZ> }
	object { Pergola_pied		translate <-EX, 0,  EZ> }
	object { Pergola_pied		translate < EX, 0,  EZ> }
	}
}

#declare Pergola_les_poutres = object
{
union	{
	box {	<-SZ_poutre, -SZ_poutre, -EZ_pergola>		,
		< SZ_poutre,  SZ_poutre,  EZ_pergola>
		translate  x*EX_pergola				}

	box {	<-SZ_poutre, -SZ_poutre,  EZ_pergola>		,
		< SZ_poutre,  SZ_poutre, -EZ_pergola>
		translate -x*EX_pergola				}

	box {	< EX_pergola, -SZ_poutre, -SZ_poutre>		,
		<-EX_pergola,  SZ_poutre,  SZ_poutre>
		translate  z*EZ_pergola				}

	box {	< EX_pergola, -SZ_poutre, -SZ_poutre>		,
		<-EX_pergola,  SZ_poutre,  SZ_poutre>
		translate -z*EZ_pergola				}
	}
pigment { color Gray80 }
}

#declare Pergola_croisillon = object
{
union {
	cylinder {	<-EX_pergola, 0,  EZ_pergola>,
			< EX_pergola, 0, -EZ_pergola>,
			SZ_poutre*0.60			}
	cylinder {	<-EX_pergola, 0, -EZ_pergola>,
			< EX_pergola, 0,  EZ_pergola>,
			SZ_poutre*0.60			}
	}
pigment { color Gray60 }
}

#declare Pergola_centre = object
{
#local H2 = 0.024;
merge	{
	sphere { 0, 0.04 scale <1, 2, 1> translate y*HK_pergola }
	cylinder { <0, 0, 0>, <0, HK_pergola, 0>, 0.02 }
	cylinder { <0, -H2, 0>, <0, H2,       0>, 0.09 }
	}
pigment { color Yellow }
#undef H2
}

#declare Pergola_faitiere = object
{
union	{
	#local R = SZ_poutre*0.89;
	cylinder { <-EX_pergola, 0, -EZ_pergola>, <0, HK_pergola, 0>, R }
	cylinder { < EX_pergola, 0, -EZ_pergola>, <0, HK_pergola, 0>, R }
	cylinder { <-EX_pergola, 0,  EZ_pergola>, <0, HK_pergola, 0>, R }
	cylinder { < EX_pergola, 0,  EZ_pergola>, <0, HK_pergola, 0>, R }
	}
pigment { color Gray80 }
}

#declare Pergola_2 = object
{
union	{
	object { Pergola_les_pieds }
	object { Pergola_centre 	translate y*H1_pergola }
	object { Pergola_les_poutres	translate y*H1_pergola }
	object { Pergola_faitiere	translate y*H1_pergola }
	object { Pergola_croisillon	translate y*H1_pergola }
	}
}

#local H_estrade = 0.33;

#declare Estrade_Pergola = object
{
#local Ex2 = EX + 0.80;
#local Ez2 = EZ + 0.90;

box { <-Ex2, 0, -Ez2>, <Ex2, H_estrade, Ez2> }
texture { T_Stone20 rotate x*45 scale 1.75 }
}

#declare Pergola_3 = object
{
union	{
	object { Estrade_Pergola				}
	object { Pergola_2 translate y*H_estrade 		}
	object { Table_Haute_Deux_Bancs translate y*H_estrade	}
	}
}

/*    ======================================================    */

#declare Poteau_Bord_Jardin = object
{
#local Hbal = 2.25;
#local Rbal = 0.06;
union	{
	box { <-Rbal, 0, -Rbal>, <Rbal, Hbal, Rbal> }
	box { <-Rbal*3, 0, -Rbal*3>, <Rbal*3, 0.05, Rbal*3> }

	
	#local D  = 0.015;
	#local E  = Rbal*3.95;
	#local HB = Hbal-0.10;
	#local HH = Hbal+0.58;

	cone { < 0, HB, -D>, Rbal, < 0, HH, -E>, 0.02 }
	cone { < 0, HB,  D>, Rbal, < 0, HH,  E>, 0.02 }
	cone { < D, HB,  0>, Rbal, < E, HH,  0>, 0.02 }
	cone { <-D, HB,  0>, Rbal, <-E, HH,  0>, 0.02 }
	}
texture {
	pigment { color rgb <0.5, 0.35, 0.75>  }
	normal { bumps 0.50 scale 0.25 }
	finish { phong PHONG specular SPECULAR  }
	}
}

/*
 *	une lampe en haut du poteau
 */
#declare Lampe_Sodium = object
{
/* taille de la boite à lumière */
#local Sxa = 0.18;
#local Sya = 0.09;
#local Sza = 0.22;
/* taille découpe de l'interieur */
#local Sxb = Sxa - 0.01;
#local Syb = Sya - 0.01;
#local Szb = Sza - 0.01;

union	{
	difference {
		box { <-Sxa, -Sya, -Sza>, <Sxb,   Sya, Sza> }
		box { <-Sxa, -Sya, -Sza>, <Sxa+1, Sya, Sza> }
		pigment { color Gray50 }
		}
	light_source {
		<0.01, 0, 0.15 >, rgb <0.70, 0.30, 0.10> // orange ou jaune ?
		fade_distance   (FADE_D * 1.10)
		fade_power      (FADE_P * 1.20)
		}
	light_source {
		<0, 0, -0.18 >, rgb <0.70, 0.30, 0.10>	// orange ou jaune ?
		fade_distance   (FADE_D * 1.10)
		fade_power      (FADE_P * 1.20)
		}

	/* assistant de visée */
	// cylinder { <2, 0, 0>, <5, 0, 0>, 0.10 pigment { color Cyan } }
	}
}

#declare Poteau_Coin_Jardin = object
{
#local Hbal = 7.95;
#local Rbal = 0.05;
union	{
	union	{
		/* le mat */
		merge {
			box { <-Rbal, 0, -Rbal>, <Rbal, Hbal, Rbal> }
			cylinder { <-Rbal, 0, 0>, <-Rbal, Hbal, 0>, Rbal }
			cylinder { < Rbal, 0, 0>, < Rbal, Hbal, 0>, Rbal }
			rotate y*45
			}
		/* la base */
		box { <-Rbal*4, 0, -Rbal*4>, <Rbal*4, 0.06, Rbal*4> }
		texture {
			pigment { color rgb <0.50, 0.75, 0.30>  }
			normal { bumps 0.55 scale 0.23 }
			finish { phong PHONG specular SPECULAR  }
			}
		}

	object { Lampe_Sodium rotate -z*48
		translate <0.09, (Hbal+0.20), 0> }

	}

#undef Hbal
#undef Rbal
}



/*    ============================================================    */

#local sX = 14;				/* les dimensions... */
#local sZ = 17;				/* ... du jardin     */
#local Ec = 0.015;			/* epaisseur cloture */

#declare Sol_Jardin = object
{
box { <-sX, 0, -sZ>, < sX, 0.004,  sZ> } 
texture { T_Wood5 rotate 17 scale 21 }
}

#declare Cloture_Bords_Jardin = object
{
box { <-sX, 0.26, Ec>, <sX, 1.65, Ec> }
texture { GRIS_BROTCH scale 20 }
}

#declare Cloture_Devant_Jardin = object
{
box { <-Ec, 0.26, -sZ>, <Ec, 1.65, -sZ*0.333> }
texture { GRIS_BROTCH scale 24 }
translate -x*sX
}

#declare Cloture_Fond_Jardin = object
{
box { <-Ec, 0.26, -sZ>, <Ec, 1.65, sZ> }
texture { GRIS_BROTCH scale 26 }
translate  x*sX
}

#declare Cloture_Du_Jardin = object
{
union	{
	object { Poteau_Coin_Jardin rotate -y*42 translate <-sX, 0, -sZ> }
	object { Poteau_Coin_Jardin rotate y*227 translate < sX, 0, -sZ> }
	object { Poteau_Coin_Jardin rotate y*45	translate <-sX, 0,  sZ> }
	object { Poteau_Coin_Jardin rotate y*135 translate < sX, 0,  sZ> }
	object { Poteau_Coin_Jardin rotate -y*12	translate <-sX, 0, -sZ*0.33>    }

	object { Poteau_Bord_Jardin	translate <  0, 0, -sZ> 	}
	object { Poteau_Bord_Jardin	translate <-sX*0.33, 0, -sZ> 	}
	object { Poteau_Bord_Jardin	translate <-sX*0.66, 0, -sZ> 	}
	object { Poteau_Bord_Jardin	translate < sX*0.33, 0, -sZ> 	}
	object { Poteau_Bord_Jardin	translate < sX*0.66, 0, -sZ> 	}
	object { Poteau_Bord_Jardin	translate <-sX*0.77, 0,  sZ> 	}
	object { Poteau_Bord_Jardin	translate < sX*0.77, 0,  sZ> 	}
	object { Poteau_Bord_Jardin	translate <  0, 0,  sZ> 	}


	object { Poteau_Bord_Jardin	translate < sX, 0, -sZ*0.25>    }
	object { Poteau_Bord_Jardin	translate < sX, 0,  sZ*0.25>    }
	object { Poteau_Bord_Jardin	translate < sX, 0, -sZ*0.50>    }
	object { Poteau_Bord_Jardin	translate < sX, 0,     0.00>    }
	object { Poteau_Bord_Jardin	translate < sX, 0,  sZ*0.50>    }
	object { Poteau_Bord_Jardin	translate < sX, 0, -sZ*0.75>    }
	object { Poteau_Bord_Jardin	translate < sX, 0,  sZ*0.75>    }

	object { Cloture_Devant_Jardin				}
	object { Cloture_Fond_Jardin				}
	object { Cloture_Bords_Jardin   translate -z*sZ		}
	object { Cloture_Bords_Jardin   translate  z*sZ		}
	}
}
/*    ======================================================    */

#declare Estrade_Ronde = object
{
merge	{
	cylinder { <0, 0, 0>, <0, 0.25, 0>, 3.79 }
	cylinder { <0, 0, 0>, <0, 0.50, 0>, 3.07 }
	}
texture { T_Stone20 rotate z*22 scale 1.95 }
}

#declare La_Quadratique = object
{
union	{
	union	{
		object { Quadratic_One translate y*H_base	}
		object { Base_Ronde 				}
		object { Cercle_de_chaises			}
		translate y*0.50
		}
	object { Estrade_Ronde }
	}
}

#declare Quatre_sculptures = object
{
union	{
	#local E = 2.83;
	object { Sculpture_0			translate <-E, 0,  0>	}
	object { Sculpture_0	rotate 189*y	translate < E, 0,  0>	}
	object { Sculpture_0	rotate  81*y	translate < 0, 0, -E>	}
	object { Sculpture_0	rotate 267*y	translate < 0, 0,  E>	}
	object { Lampe_Rotonde	rotate y*35*NormClock translate 0.09*x	}
	#undef E
	}
}
/*    ======================================================    */

  		/********************************/
  		/*     ASSEMBLAGE DU JARDIN     */
  		/********************************/

#declare Le_Premier_Jardin = object
{
union	{
	object { Sol_Jardin						}
	object { Cloture_Du_Jardin 					}

	object { Lampe_Jardin rotate y*34 translate <-4.65, 0, -6.25>	}

	#local dZ = sZ * 0.333;
	#local SC = 1.333;
	#local dX = sX + 2.90;
	object { Barriere scale SC rotate y*90 translate <-dX, 0, -dZ>	}
	object { Barriere scale SC rotate y*90 translate <-dX, 0,  dZ>	}
	object { Barriere scale SC rotate y*90 translate <-dX, 0,  sZ>	}
	#local dX = sX + 5.80;
	object { Barriere scale SC rotate y*90 translate <-dX, 0, -dZ>	}
	object { Barriere scale SC rotate y*90 translate <-dX, 0,  dZ>	}
	object { Barriere scale SC rotate y*90 translate <-dX, 0,  sZ>	}
	#local dX = sX + 8.70;
	object { Barriere scale SC rotate y*90 translate <-dX, 0, -dZ>	}
	object { Barriere scale SC rotate y*90 translate <-dX, 0,  dZ>	}
	object { Barriere scale SC rotate y*90 translate <-dX, 0,  sZ>	}
	#undef SC

	object { Totem_Jardin translate <10.75, 0, -9.30> }

	object { Pergola_3		translate < 6.25, 0, 2.90>	}
	object { Rang_Barriere_4	translate < 1.35, 0, 2.45>	}

	object { Pyramide
		rotate y*((NormClock*NormClock)*768)
		translate <4.40+Cos_010(NormClock), 20.33*NormClock,
						-8.9+(NormClock * 2.15)>
		}

	object { Four_Leef rotate y*45	translate < sX*0.33, 0, sZ-3.95>	}
	object { Four_Leef rotate y*45	translate < sX*0.65, 0, sZ-4.17>	}

	object { Poteau_Cactus		translate <-sX*0.58, 0, sZ-2.90>	}
	object { Quatre_sculptures rotate y*40	translate <-5.10, 0, 4.63> 	}

	object { Le_Clocheton rotate y*10 translate <-(sX-1.11), 0,  sZ*0.30> }

	object { La_Quadratique translate <-7.87, 0, -10.97> }
	}
}

/*    ======================================================    */




